/*
 * global assertion
 * this must hold everytime
 */

import daj.*;
import java.util.LinkedList;
import java.lang.Integer;


class Assertion extends GlobalAssertion {

    // nodes in CRIT
    private LinkedList nodes;


    public Assertion() {
        super();
        nodes = new LinkedList();
    }


    public String getText() {
        String error = "nodes in CRIT:";

        for (int i = 0; i < nodes.size(); i++)
            error += " " + ((Integer)nodes.get(i)).intValue();

        return error;
    }


    /*
     * only one node may be in CRIT
     */
    public boolean assert(Program program[]) {
        int counter = 0;

        nodes.clear();

        for (int i = 0; i < program.length; i++) {
            if (((LogicalTimeME)program[i]).region == LogicalTimeME.regionCRIT) {
                counter++;
                nodes.addLast(new Integer(i));
            }
        }
        return counter <= 1;
    }
}
